<template lang="pug">
.programs
  h1.programs__title Образовательные программы
  .programs__filter
    .programs__filter-wrapper
      .programs__filter-icon(:class="filtered.class")
        span {{ filtered.title }}
      .programs__filter-main

        .programs__filter-select
          .programs__filter-select-text Область образования:
          select(v-model="filterArea")
            option(value="Академическое") Академическое
            option(value="Творческое") Творческое
            option(value="Физиологическое") Физиологическое
            option(value="Социальное") Социальное

        .programs__filter-select
          .programs__filter-select-text Уровень сложности:
          select(v-model="filterLevel")
            option(value="Легкий уровень") Легкий уровень
            option(value="Средний уровень") Средний уровень
            option(value="Сложный уровень") Сложный уровень

        .programs__filter-select
          .programs__filter-select-text Тип урока:
          select(v-model="filterType")
            option(value="Лекция") Лекция
            option(value="Игра") Игра
            option(value="Презентация") Презентация
            option(value="Тест") Тест

      .programs__filter-reset(@click="reset")
        img(src="@/assets/icon_sbros.png")
        div Сброс
  .programs__list(v-if="items.length")
    Card(
      v-for="item, index in filteredItems"
      :key="item.id"
      :item="item"
      type="program"
      :number="index"
      :numberDouble=9
    )
    Error(v-if="error.status") {{ error.msg }}
  .programs__nothing(v-if="!filteredItems.length") Ничего не найдено!
</template>

<script>
import Error from '@/components/parts/Error.vue'
import Card from '@/components/parts/Card.vue'
import Select from '@/components/parts/Card.vue'

export default {
  name: 'Programs',
  components: {
    Card,
    Error
  },
  data() {
    return {
      filterArea: '',
      filterLevel: '',
      filterType: '',
      data: [],
      error: {
        status: false,
        msg: 'Неверный логин или пароль'
      }
    }
  },
  computed: {
    items() {
      const { data, item, selectedType } = this
      return (!selectedType)
        ? data
        : data.filter(item => {return (item.program_type_id === selectedType)})
    },
    filteredItems() {
      const { items } = this
      return items.filter(item => {
        const isType = this.filterType ? item.program_type_name === this.filterType : true
        const isLevel = this.filterLevel ? item.complexity_type_name === this.filterLevel : true
        const isArea = this.filterArea ? item.program_edu_area_name === this.filterArea : true
        return (isType && isLevel && isArea)
      })
    },
    filtered() {
      let name
      switch (this.filterArea) {
        case 'Академическое':
          name = 'academ'
          break
        case 'Творческое':
          name = 'paint'
          break
        case 'Физиологическое':
          name = 'sport'
          break
        case 'Социальное':
          name = 'social'
          break
        default:
          name = 'all'
      }
      return { class: name, title: this.filterArea || 'Все области'}
    }
  },
  watch: {
    '$route' (to, from) {
      const typesEnum = Object.freeze({"all":0, "social":1, "science":2, "paint":3, "sport":4, "tech":5})
      const type = typesEnum[to.params.type]
      this.selectedType = type
    }
  },
  created: async function() {
    try {
      const response = await this.$store.dispatch('getPrograms')
      this.data = this.$store.getters.programs
    } catch (e) {
      this.error.status = true
      this.error.msg = 'Ошибка'
      throw e
    }
  },
  methods: {
    reset: function() {
      this.filterArea = ''
      this.filterLevel = ''
      this.filterType = ''
    }
  }
}
</script>

<style lang="stylus" scoped>
@import '~@/stylus/mixins.styl'

.programs
  max-width: unset
  &__title
    font-size: 2em
    text-align: center
    margin: 15px 0 0
    color: mainColor
  &__categories
    width: 100%
    margin: 20px 0
    background: #929292
    &_wrapper
      max-width: 1200px
      margin: auto
      display: flex
      flex-direction: row
      justify-content: space-between
  &__list
    max-width: 1200px
    display: flex
    flex-wrap: wrap
    margin: auto
  &__nothing
    width: 100%
    max-width: 1200px
    margin: auto;
    background: #ddd
    border-radius: 10px
    text-align: center
    font-weight: 700
    padding: 15px
    color: #222

  &__filter
    width: 100%
    background: #929292
    margin: 15px 0
    padding: 5px 0 30px
    &-wrapper
      max-width: 1200px
      margin: auto
      display: flex
      justify-content: space-between
      flex-direction: row
    &-reset
      display: flex
      justify-content: center
      cursor: pointer
      flex-direction: column
      align-items: center
      color: lightColor
      position: relative
      top: 13px
      img
        height: 40px
        filter: invert(100%)
    &-main
      display: flex
      justify-content: space-between
      flex-grow: 1
      color: white
      align-items: center
      position: relative
      top: 10px
      margin-right: 30px
      select
        border: none
        border-radius: 10px
        padding: 5px
        width: 100%
    &-select
      padding: 0 15px
      width: 33%
    &-icon
      background-size: 50px !important
      background-position: center !important
      background-repeat: no-repeat !important
      filter: invert(100%)
      width: 170px
      text-align: center
      &::after
        content: ''
      span
        position: relative
        top: 60px
        font-weight: 700
      &.sport
        background: url('../assets/program_sport.png')
      &.social
        background: url('../assets/program_social.png')
      &.all
        background: url('../assets/icon_category_program.png')
      &.academ
        background: url('../assets/program_academ.png')
      &.paint
        background: url('../assets/program_paint.png')
</style>
